Package com.sas.metadata.remote

# Interface MdObjectBaseUtil

All Superinterfaces:
  `MdObjectBase`, `Remote`

All Known Subinterfaces:
  `AbstractExtension`, `AbstractJob`, `AbstractPrompt`, `AbstractProperty`, `AbstractTransformation`, `AccessControl`, `AccessControlEntry`, `AccessControlTemplate`, `Action`, `Aggregation`, `AnalyticColumn`, `AnalyticContext`, `AnalyticTable`, `ApplicationAction`, `ArchiveEntry`, `ArchiveFile`, `AssociationProperty`, `AttributeProperty`, `AuthenticationDomain`, `CalculatedMeasure`, `CalculatedMember`, `Change`, `Classifier`, `ClassifierMap`, `CMetadata`, `Column`, `ColumnHierarchy`, `ColumnRange`, `COMConnection`, `Condition`, `ConditionActionSet`, `ConditionalPrecedence`, `ConfiguredComponent`, `Connection`, `ContentLocation`, `ContentType`, `Cube`, `CustomAssociation`, `DatabaseCatalog`, `DatabaseSchema`, `DataSourceName`, `DataTable`, `DeployedComponent`, `DeployedDataPackage`, `Device`, `DeviceType`, `Dimension`, `Directory`, `Document`, `Email`, `Event`, `Extension`, `ExternalIdentity`, `ExternalTable`, `FavoritesContainer`, `Feature`, `FeatureMap`, `File`, `FitStatistic`, `ForeignKey`, `GlobalFormula`, `Group`, `GroupByClause`, `HavingClause`, `Hierarchy`, `HierarchyLevel`, `Identity`, `IdentityGroup`, `Index`, `InternalLogin`, `ITChannel`, `ITContentSubscriber`, `ITEventSubscriber`, `ITFilter`, `ITSubscriber`, `JFJob`, `Job`, `Join`, `JoinTable`, `Key`, `KeyAssociation`, `Keyword`, `Level`, `LocalizedResource`, `LocalizedType`, `Location`, `LogicalColumn`, `LogicalServer`, `Login`, `Machine`, `MdObjectBaseXML`, `Measure`, `Memory`, `MiningResult`, `NamedService`, `NamedSet`, `NumericExtension`, `OLAPProperty`, `OLAPSchema`, `OnClause`, `OpenClientConnection`, `OrderByClause`, `Permission`, `PermissionCondition`, `Person`, `Phone`, `PhysicalTable`, `PrimaryType`, `Prompt`, `PromptGroup`, `Property`, `PropertyGroup`, `PropertySet`, `PropertyType`, `Prototype`, `PrototypeProperty`, `PSColumnLayoutComponent`, `PSLayoutComponent`, `PSPortalPage`, `PSPortalProfile`, `PSPortlet`, `QueryClause`, `QueryTable`, `RelationalSchema`, `RelationalTable`, `Report`, `ResponsibleParty`, `Role`, `Root`, `RowSelector`, `SASCatalog`, `SASCatalogEntry`, `SASClientConnection`, `SASFileRef`, `SASLibrary`, `SASLicense`, `SASPassword`, `Search`, `SecondaryType`, `SecuredLibrary`, `SecuredTable`, `SecurityRule`, `SecurityRuleScheme`, `SecurityTypeContainmentRule`, `Select`, `ServerComponent`, `ServerContext`, `ServiceComponent`, `ServiceType`, `SharedDimension`, `SoftwareComponent`, `StepPrecedence`, `Stream`, `SXLEMap`, `SyncStep`, `TableCollection`, `Target`, `TCPIPConnection`, `Text`, `TextStore`, `Timestamp`, `Transformation`, `TransformationActivity`, `TransformationStep`, `Tree`, `TSNameObject`, `TSNamespace`, `TypeDefinition`, `UniqueKey`, `UnitofTime`, `Variable`, `WhereClause`, `WorkTable`, `XPath`

public interface MdObjectBaseUtil extends MdObjectBase
Provides the Store object and event interactions for Metadata objects.

- ## Field Summary

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addMdObjectListener(MdObjectListener l)`
  Used to add an object to the list of listeners for changes in the Metadata Object.
  `boolean`
  `delete()`
  Marks an object as deleted in the owning store and does not allow for retrival of that object.
  `void`
  `dispose()`
  Removes all links to this object so it can be garbage collected.
  `void`
  `fireMdObjectModified(MdEvent e)`
  Used to notify all the listeners in the listner list of changes in the metadata object.
  `AssociationList`
  `getAssociatedObjects(String strAssociation)`
  Helper method for getting associated metadata objects.
  `AssociationList`
  `getAssociatedObjects(String strAssociation, String strTemplate)`
  Helper method for getting associated metadata objects.
  `AssociationList`
  `getAssociatedObjects(String associationType, String strAssociation, boolean isPredAssoc, String Properties, CMetadata parentObj)`
  Helper method for getting associated metadata objects.
  `List<String>`
  `getAssociationNames()`
  Returns a list of the association names for this object.
  `Map<String,AssociationList>`
  `getAssocs()`
  Gets the Map of all associations this object has.
  `Map<String,AssociationList>`
  `getAssocsWA()`
  Gets the Map of all associations this object has.
  `List<String>`
  `getAttributeNames()`
  Returns a list of the attribute names for this object.
  `Map<String,String>`
  `getAttrs()`
  Gets the Map of all attributes this object has.
  `Map<String,Integer>`
  `getAttrsStates()`
  Gets the Map of all attributes states this object has.
  `int`
  `getChangeManagementState()`
  Returns the state of this object in a project repository
  `int`
  `getChgMgtExternalIdentityImportType()`
  Deprecated.
  As of 9.2 this method is no longer supported
  `Object`
  `getClientSideOnlyObject()`
  Gets the client-side-only object that is attached to the metadata object.
  `AssociationList`
  `getMdObjectAssociation(String associationName)`
  (S) Set's the list into the object using the set method internally.
  `Map<String,AssociationList>`
  `getPopulatedAssocs()`
  Gets a Map of all associations that have been populated, either by the client or the server.
  `Map<String,String>`
  `getUpdatedAttrs()`
  Returns a map of all attributes that have been updated locally by the client.
  `ArrayList`
  `getViewList()`
  Get all the views associated with this metadata object.
  `void`
  `initializeRequiredObjects()`
  Used at constructor time to initialize the required objects array
  `boolean`
  `isCheckedOut()`
  Tells whether or not this object in the checked out state in the project repository
  `boolean`
  `isLocked()`
  Tells whether on not this object is locked in a repository.
  `boolean`
  `objectModified()`
  Tells whether any of the attributes or associationLists on this object have been changed.
  `void`
  `removeMdObjectListener(MdObjectListener l)`
  Used to remove an object from the list of listeners for changes in the Metadata Object.
  `void`
  `setAttrs(Map<String,MdObjectAttribute> attrMap)`
  (S) Sets the Map of all attributes this object has.
  `void`
  `setChangeManagementTargetRepository(String targetRepos)`
  Deprecated.
  As of 9.2 this method is no longer supported
  `void`
  `setChgMgtExternalIdentityImportType(int type)`
  Deprecated.
  As of 9.2 this method is no longer supported
  `void`
  `setClientSideOnlyObject(Object oObject)`
  Sets the client-side-only object that is attached to the metadata object.
  `void`
  `setMdObjectAssociation(AssociationList inList)`
  Set's the list into the object using the set method internally.
  `void`
  `touch()`
  Touches the object so that its last modified date will be updated the next time this object is persisted to the server.
  `void`
  `updateAssnsIds(String oldID, String newID)`
  Updates the ids in the association lists contained in this object.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, initializePredObjects, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

- ## Method Details

  - ### getAttributeNames

    List<String> getAttributeNames() throws RemoteException
    Returns a list of the attribute names for this object.
    Returns:
      List (of Strings) of attribute names
    Throws:
      `RemoteException`

  - ### getAssociationNames

    List<String> getAssociationNames() throws RemoteException
    Returns a list of the association names for this object.
    Returns:
      List (of Strings) of association names
    Throws:
      `RemoteException`

  - ### getAttrs

    Map<String,String> getAttrs() throws RemoteException
    Gets the Map of all attributes this object has.
    Returns:
      Map of attributes.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### setAttrs

    void setAttrs(Map<String,MdObjectAttribute> attrMap) throws RemoteException
    (S) Sets the Map of all attributes this object has.
    Parameters:
      `Map` - of attributes.
    Throws:
      `RemoteException`

  - ### getUpdatedAttrs

    Map<String,String> getUpdatedAttrs() throws RemoteException
    Returns a map of all attributes that have been updated locally by the client. All updated attributes have a state set to `MetadataState.LOCAL`.
    Returns:
      map of updated attributes
    Throws:
      `RemoteException`

  - ### getAttrsStates

    Map<String,Integer> getAttrsStates() throws RemoteException
    Gets the Map of all attributes states this object has.
    Returns:
      Map of attribute states.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### getAssocs

    Map<String,AssociationList> getAssocs() throws RemoteException
    Gets the Map of all associations this object has.
    Returns:
      Map of associations.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### getPopulatedAssocs

    Map<String,AssociationList> getPopulatedAssocs() throws RemoteException
    Gets a Map of all associations that have been populated, either by the client or the server. Only associations that have previously been set will be included in the map.
    Returns:
      map of set associations
    Throws:
      `RemoteException`

  - ### getAssocsWA

    Map<String,AssociationList> getAssocsWA() throws RemoteException
    Gets the Map of all associations this object has.
    Returns:
      Map of associations.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### setMdObjectAssociation

    void setMdObjectAssociation(AssociationList inList) throws RemoteException
    Set's the list into the object using the set method internally.
    Parameters:
      `inList` - list to be set for the association.
    Throws:
      `RemoteException`

  - ### getMdObjectAssociation

    AssociationList getMdObjectAssociation(String associationName) throws RemoteException, MdException
    (S) Set's the list into the object using the set method internally.
    Parameters:
      `inList` - list to be set for the association.
    Returns:
      List if found, null otherwise.
    Throws:
      `RemoteException`
      `MdException`

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    Used at constructor time to initialize the required objects array
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### addMdObjectListener

    void addMdObjectListener(MdObjectListener l) throws RemoteException
    Used to add an object to the list of listeners for changes in the Metadata Object.
    Parameters:
      `l` - MetadataListener
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### removeMdObjectListener

    void removeMdObjectListener(MdObjectListener l) throws RemoteException
    Used to remove an object from the list of listeners for changes in the Metadata Object.
    Parameters:
      `l` - MetadataListener
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### fireMdObjectModified

    void fireMdObjectModified(MdEvent e) throws RemoteException
    Used to notify all the listeners in the listner list of changes in the metadata object.
    Parameters:
      `e` - ChangeEvent Created like: `new ChangeEvent(Object generator)`
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### getViewList

    ArrayList getViewList() throws RemoteException
    Get all the views associated with this metadata object.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### getAssociatedObjects

    AssociationList getAssociatedObjects(String strAssociation) throws MdException, RemoteException
    Helper method for getting associated metadata objects.
    Parameters:
      `strAssociation` - String
    Returns:
      AssociationList
    Throws:
      `MdException` - if error getting the data
      `RemoteException` - if connection to object is lost.

  - ### getAssociatedObjects

    AssociationList getAssociatedObjects(String associationType, String strAssociation, boolean isPredAssoc, String Properties, CMetadata parentObj) throws MdException, RemoteException
    Helper method for getting associated metadata objects.
    Parameters:
      `associationType` - String The type of association "Column-Table"
      `strAssociation` - String The name of the association "Colums"
      `isPredAssoc` - boolean
      `Properties` - String String for cardinalities and req for add
      `parentObj` - CMetadata the object that owns the associaition.
    Returns:
      AssociationList
    Throws:
      `MdException` - if error getting the data
      `RemoteException` - if connection to object is lost.

  - ### getAssociatedObjects

    AssociationList getAssociatedObjects(String strAssociation, String strTemplate) throws MdException, RemoteException
    Helper method for getting associated metadata objects.
    Parameters:
      `strAssociation` - String The name of the association "Colums"
      `strTemplate` - String
    Returns:
      AssociationList
    Throws:
      `MdException` - if error getting the data
      `RemoteException` - if connection to object is lost.

  - ### delete

    boolean delete() throws RemoteException
    Marks an object as deleted in the owning store and does not allow for retrival of that object.
    Returns:
      boolean if object state set to deleted
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### dispose

    void dispose() throws RemoteException
    Removes all links to this object so it can be garbage collected.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### touch

    void touch() throws RemoteException
    Touches the object so that its last modified date will be updated the next time this object is persisted to the server. Note: this method will not automatically update the object on the server. The client will have to either persist the object or its owning store.
    Throws:
      `RemoteException`

  - ### objectModified

    boolean objectModified() throws RemoteException
    Tells whether any of the attributes or associationLists on this object have been changed.
    Returns:
      true if object has changed.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### updateAssnsIds

    void updateAssnsIds(String oldID, String newID) throws RemoteException
    Updates the ids in the association lists contained in this object.
    Parameters:
      `oldID` - String
      `newID` - String
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### getClientSideOnlyObject

    Object getClientSideOnlyObject() throws RemoteException
    Gets the client-side-only object that is attached to the metadata object. The client-side-only object is created on the client and is never persisted. The reason for the name is to avoid collisions with attributes that might be added to detailed metadata objects in the future.
    Returns:
      the client-side-only object.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### setClientSideOnlyObject

    void setClientSideOnlyObject(Object oObject) throws RemoteException
    Sets the client-side-only object that is attached to the metadata object. The client-side-only object is create on the client and is never persisted. The reason for the name is to avoid collisions with attributes that might be added to detailed metadata objects in the future.
    Parameters:
      `oObject` - the client-side-only object
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### isLocked

    boolean isLocked() throws RemoteException
    Tells whether on not this object is locked in a repository.
    Returns:
      boolean if the object is locked for change management.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### isCheckedOut

    boolean isCheckedOut() throws RemoteException
    Tells whether or not this object in the checked out state in the project repository
    Returns:
      boolean if the object is in the checked out state in the project repository
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### getChangeManagementState

    int getChangeManagementState() throws RemoteException
    Returns the state of this object in a project repository
    Returns:
      an int indicating the state of the object in the project repository
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### setChangeManagementTargetRepository

    void setChangeManagementTargetRepository(String targetRepos) throws RemoteException
    Deprecated.
    As of 9.2 this method is no longer supported
    Sets the repository objects will reside in.
    Parameters:
      `targetRepos` - String the string name for the Identity value of the ExternalIdentity object connected to this one.
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### setChgMgtExternalIdentityImportType

    void setChgMgtExternalIdentityImportType(int type) throws RemoteException
    Deprecated.
    As of 9.2 this method is no longer supported
    Sets the change management's external identity object's ImportType for the type of change management object this is. Valid types are:
    MetadataState.MD_CHGMGT_FETCHED MetadataState.MD_CHGMGT_NEW MetadataState.MD_CHGMGT_UNSET MetadataState.MD_CHGMGT_CHECKEDOUT
    Parameters:
      `type` - int
    Throws:
      `RemoteException` - if connection to object is lost.

  - ### getChgMgtExternalIdentityImportType

    int getChgMgtExternalIdentityImportType() throws RemoteException
    Deprecated.
    As of 9.2 this method is no longer supported
    Gets the change management's external identity object's ImportType for the type of change management object this is. Valid types are:
    MetadataState.MD_CHGMGT_FETCHED MetadataState.MD_CHGMGT_NEW MetadataState.MD_CHGMGT_UNSET MetadataState.MD_CHGMGT_CHECKEDOUT
    Returns:
      int type of object.
    Throws:
      `RemoteException` - if connection to object is lost.